﻿Option Infer On

Imports System.IO
Imports System.Data
Imports System.Drawing
Imports System.Windows.Forms

Module Module1

    Sub Main()

        'Simply comment out for the other samples for this chapter!
        'BooleanTest()
        'ArrayTest()
        'DoLoopDemo()
        'ConditionCheck()
        'MultiplikationMitBitverschiebung()
        'Nullables()
        'Console.ReadKey()
        'Return

        'Sample used in the figure of the first chapter.
        Dim input As String
        Do
            'Print text to console window:
            Console.Write("Please enter your date of birth (mm/dd/yyyy): ")

            'Read user's input and store it in variable 'input'
            input = Console.ReadLine

            'Branch conditionally
            If input = "time" Then
                Console.WriteLine("At the tone, the time will be: " & Date.Now.ToShortTimeString)
                Console.WriteLine()
                Beep()
            ElseIf input = "today" Then
                Console.WriteLine("Today is {0}, the {1}",
                                  Now.ToString("dddd"),
                                  Now.ToString("MMMM, dd. yyyy"))
                Console.WriteLine()
            Else
                If input IsNot Nothing AndAlso input.Length > 6 Then
                    Try
                        Dim yearOfBirth As Date
                        Dim age As Integer

                        'Convert string of characters into a real date:
                        yearOfBirth = Date.Parse(input)
                        'call a function to calculate a value
                        age = CalcAge(yearOfBirth)
                        Console.WriteLine("You are {0} years old!", age)
                        Console.WriteLine()
                        Console.WriteLine()
                    Catch ex As Exception
                        Console.WriteLine("Error: Your input wasn't" &
                                          "of the right date format!")
                        Console.WriteLine(ex.Message)
                        Console.WriteLine()
                    End Try
                End If
            End If
            'As long as user didn't just press return, loop commands between do and loop.
        Loop While Not String.IsNullOrWhiteSpace(input)
    End Sub

    ''' <summary>
    ''' Calculates the age in years from a given date.
    ''' </summary>
    ''' <param name="yearOfBirth">The date of birth used for the calculation of the age.</param>
    ''' <returns>The age in years.</returns>
    ''' <remarks>There is nothing to remark, here.</remarks>
    Function CalcAge(yearOfBirth As Date) As Integer
        Dim ageToReturn As Integer
        Dim today As Date = Date.Today
        Dim diffToDateOfBirth As TimeSpan

        diffToDateOfBirth = today.Subtract(yearOfBirth)
        ageToReturn = diffToDateOfBirth.Days \ 365
        Return ageToReturn
    End Function
End Module

Public Module Testmodul

    Sub BooleanTest()
        Dim var = 5 = 5
        Console.WriteLine(var.ToString)
    End Sub

    Sub ArrayTest()
        Dim Name1 As String = "Adriana Ardelean"
        Dim Name2 As String = "Sarika Calla"
        Dim Name3 As String = "Ramona Leenings"
        Dim Name4 As String = "Beth Messi"
        Dim Name5 As String = "Lisa Feigenbaum"

        Dim Names() As String = {"Adriana Ardelean",
                                 "Sarika Calla",
                                 "Ramona Leenings",
                                 "Beth Messi",
                                 "Lisa Feigenbaum"}

        Dim NameNo As Integer = 3
        Console.WriteLine(Names(NameNo))
        Console.WriteLine("-------------------------")

        Dim otherNames As New List(Of String)
        otherNames.Add("Adriana Ardelean")
        otherNames.Add("Sarika Calla")
        otherNames.Add("Ramona Leenings")
        otherNames.Add("Beth Messi")
        otherNames.Add("Lisa Feigenbaum")

        'You can access a dynamic list 
        'via indexer, as you do with Arrays.
        Console.WriteLine(otherNames(NameNo))
        Console.WriteLine("-------------------------")

        'Iterate with a For-Loop and print each element.
        For index As Integer = 0 To Names.Length - 1
            Console.WriteLine(Names(index))
        Next
        Console.WriteLine("-------------------------")

        'Iterate with ForEach and print each element.
        For Each name In Names
            Console.WriteLine(name)
        Next
        Console.WriteLine("-------------------------")

        'Last element in list gets "special treatment".
        For index As Integer = 0 To Names.Length - 1
            If index < Names.Length - 1 Then
                Console.WriteLine(Names(index))
            Else
                Console.WriteLine("and last but not least: " & Names(index))
            End If
        Next
        Console.WriteLine("-------------------------")
    End Sub

    Sub DoLoopDemo()

        Dim Namen() As String = {"Adriana Ardelean",
                                    "Sarika Calla",
                                    "Ramona Leenings",
                                    "Beth Messi",
                                    "Lisa Feigenbaum"}

        'Print elements firstly in ascending order ...
        Dim index As Integer = 0
        Do While index < Namen.Length
            Console.WriteLine(Namen(index))
            index += 1
        Loop

        Console.WriteLine("-------------------------")
        Console.WriteLine("      and descending:")
        Console.WriteLine("-------------------------")

        '... and then in descending order:
        index = Namen.Length - 1
        While index > -1
            Console.WriteLine(Namen(index))
            index -= 1
        End While

    End Sub

    Sub ConditionCheck()

        'Present user options and read user's input from keyboard:
        Console.Write("What function would you like to execute (1-9, 0 or 'end' to quit program): ")
        Dim input = Console.ReadLine

        'If user enters "0" or "end" ...
        If input = "0" Or input.ToUpper = "END" Then
            '... exit method.
            'NOTE: We convert all characters the user enters to capital letters (ToUpper),
            'so it doen't matter if the user types lower case, upper case or mixed letters.
            Exit Sub
        End If

        'if the entered character is greater or equals "1" AND is smaller or equals "9"...
        If input.Length = 1 And input >= "1" And input <= "9" Then
            '...it was a valid choice...
            Console.WriteLine("You picked a valid option!")
            '...else
        Else
            '...not.
            Console.WriteLine("You choice was not valid.")
        End If
    End Sub

    Public Sub MultiplicationWithBitShifting()
        Dim value1, value2, resultValue, helperValue As Integer
        value1 = 10
        value2 = 5
        resultValue = 0
        helperValue = value2

        'This algorithm works the same way you would multiply
        'numbers in the decimal number system manualy:
        '
        '(10)   (5)
        '1010 * 101 =
        '------------
        '      1010 +
        '     0000  +
        '    1010
        '------------
        '    101010 = 50

        'To that end, the "5" is shifted to the right bitwise,
        'to test its outer right bit. If it is set,
        'the value 10 is first added, and then its
        'complete "bit content" is moved one place to the left; 
        'when it is not set, nothing happens.
        'This process repeats until all
        'bits of "5" are used up, i.e. the variable helpValue,
        'which processes this value, has become 0.
        'For a multiplication, as many additions are necessary 
        'as there are bits set in the second value.
        Do
            If (helperValue And 1) = 1 Then
                resultValue += value1
            End If
            value1 = value1 << 1
            helperValue = helperValue >> 1
        Loop Until helperValue = 0
        Console.WriteLine("The result value is:" & resultValue)
    End Sub

    Public Sub Nullables()

        Dim count As Integer
        count = count + 1
        Console.WriteLine("Count is: " & count.ToString)

        Dim nullableCount As Integer?
        nullableCount = 0
        nullableCount = nullableCount + 1
        Console.WriteLine("Nullable Count is: " & nullableCount.ToString)

        Dim anotherNullable As Integer?         ' Doesn't have a value or value is not known.
        anotherNullable = anotherNullable + 1   ' And it stays that way.
        Console.WriteLine("anotherNullable is: " & anotherNullable.ToString)

        Console.WriteLine("Does nullableCount has a value? " & nullableCount.HasValue.ToString)
        Console.WriteLine("Does anotherNullable has a value? " & anotherNullable.HasValue.ToString)
    End Sub
End Module

Module TypeSafety

    Sub TypeSafety()

        'Not type safe: String --> Char doesn't compile.
        'Dim aChar As Char = "H"

        'Is ok: type literal defined of type char.
        Dim anOtherChar As Char = "H"c

        'Doesn't work again: char demands only one character.
        'Dim yetAnotherChar As Char="Hallo"c


        Dim aString As String
        'aString = 3.14159

        Dim aLong As Long = 1000
        Dim anInteger As Integer

        'anInteger = aLong
    End Sub

End Module

Module WithDemo

    Sub Test()

        Dim myForm As New Form
        With myForm
            .Text = "Window title"          ' Instead of myForm.Text = ...
            .Location = New Point(100, 100) ' Instead of myForm.Location = ...
            .Size = New Size(200, 200)
        End With
    End Sub

    Sub FiveFoundDemo()

        Dim fiveFound As Boolean

        For counter As Integer = 0 To 10
            If counter = 5 Then
                fiveFound = True
            End If
            For secondCounter As Integer = 0 To 10
                If secondCounter = 5 Then
                    fiveFound = True
                End If
            Next
        Next

        If fiveFound Then
            Debug.Print("The number 5 was part of the list of numbers!")
        End If
    End Sub

End Module
