Imports System.Globalization

Module Module1

    Sub Main()

        Dim midnight As Date = #12:00:00 AM#
        Dim noon As Date = #12:00:00 PM#
        Dim NewYearsEve As System.DateTime = #12/31/2004#
        Dim TimeForChampagne As System.DateTime = #12/31/2004 11:58:00 PM#
        Dim TimeForAsperin As System.DateTime = #1/1/2005 11:58:00 AM#

        Dim locDate1 As Date = #3:15:00 PM#
        Dim locDate2 As Date = #4:23:32 PM#
        Dim locTimeSpan As TimeSpan = locDate2.Subtract(locDate1)
        Console.WriteLine("The time span between {0} and {1} is", _
                            locDate1.ToString("HH:mm:ss"), _
                            locDate2.ToString("HH:mm:ss"))

        Console.WriteLine("{0} second(n) or", locTimeSpan.TotalSeconds)
        Console.WriteLine("{0} minute(n) and {1} second(n) or", _
                            Math.Floor(locTimeSpan.TotalMinutes), _
                            locTimeSpan.Seconds)
        Console.WriteLine("{0} hour(s), {1} minute(s) and {2} second(s) or", _
                            Math.Floor(locTimeSpan.TotalHours), _
                            locTimeSpan.Minutes, locTimeSpan.Seconds)
        Console.WriteLine("{0} Ticks", _
                            locTimeSpan.Ticks)

        Dim locToParse As Date

        locToParse = Date.Parse("13.12.10") ' OK, basic European setting is processed.
        locToParse = Date.Parse("6/7/10") ' OK, but European date is used in spite of "/".
        locToParse = Date.Parse("13/12/10") ' OK, as above.
        locToParse = Date.Parse("06.07") ' OK, is extended by the year.
        locToParse = Date.Parse("06,07,10") ' OK, comma is acceptable.
        locToParse = Date.Parse("06,07") ' OK, comma is acceptable; year is added.

        'locToParse = Date.Parse("06072010") ' --> Exception: was not recognized as a valid date!
        'locToParse = Date.Parse("060705") ' --> Exception: was not recognized as a valid date!

        locToParse = Date.Parse("6,7,4") ' OK, comma is acceptable; leading zeros are added.
        locToParse = Date.Parse("14:00") ' OK, 24-hour display is acceptable.
        locToParse = Date.Parse("PM 11:00") ' OK, PM may be in front of...
        locToParse = Date.Parse("11:00 PM") ' ...and behind the time specification.

        'locToParse = Date.Parse("12,00 PM") ' --> Exception: was not recognized as a valid date!
        'Both date/time combinations work:
        locToParse = Date.Parse("6.7.10 13:12")
        locToParse = Date.Parse("6,7,10 11:13 PM")


        Dim locToParseExact As Date
        Dim locTimePattern As String() = {"H,m", "H.m", "ddMMyy", "MM\/dd\/yy"}

        'Works: it's in the time pattern.
        locToParseExact = Date.ParseExact("12,00", _
                                            locTimePattern, _
                                            CultureInfo.CurrentCulture, _
                                            DateTimeStyles.AllowWhiteSpaces)


        'Works: it's in the time pattern, and whitespaces are permitted.
        locToParseExact = Date.ParseExact(" 12 , 00 ", _
                                            locTimePattern, _
                                            CultureInfo.CurrentCulture, _
                                            DateTimeStyles.AllowWhiteSpaces)

        'Doesn't work: it's in the time pattern, but whitespaces are not permitted.
        'locToParseExact = Date.ParseExact(" 12 , 00 ", _
        '                                   locTimePattern, _
        '                                   CultureInfo.CurrentCulture, _
        '                                   DateTimeStyles.None)

        'Works: it's in the time pattern.
        locToParseExact = Date.ParseExact("1,2", _
                                            locTimePattern, _
                                            CultureInfo.CurrentCulture, _
                                            DateTimeStyles.None)

        'Works: it's in the time pattern.
        'But the date corresponds to 1.1.0001 and is therefore
        'not displayed as a Tooltip, contrary to all the other
        'examples shown here.
        locToParseExact = Date.ParseExact("12.2", _
                                            locTimePattern, _
                                            CultureInfo.CurrentCulture, _
                                            DateTimeStyles.NoCurrentDateDefault)

        'Doesn't Work: it's not in the time pattern, because seconds are also used:
        'locToParseExact = Date.ParseExact("12,2,00", _
        '                                  locTimePattern, _
        '                                  CultureInfo.CurrentCulture, _
        '                                  DateTimeStyles.NoCurrentDateDefault)


        'Doesn't work: the colon is not in the time pattern.
        'locToParseExact = Date.ParseExact("1:20", _
        '                                  locTimePattern, _
        '                                  CultureInfo.CurrentCulture, _
        '                                  DateTimeStyles.None)

        'Now it works, because it's used as date in the time pattern.
        '(third element in the string array)
        locToParseExact = Date.ParseExact("241205", _
                                locTimePattern, _
                                CultureInfo.CurrentCulture, _
                                DateTimeStyles.AllowWhiteSpaces)

        'Works: US format is used,
        'as defined by the slashes and the group order.
        '(fourth element in the string array).
        locToParseExact = Date.ParseExact("12/24/05", _
                                        locTimePattern, _
                                        CultureInfo.CurrentCulture, _
                                        DateTimeStyles.AllowWhiteSpaces)

        Console.ReadLine()
    End Sub

End Module
