Imports System.Threading

Module mdlMain

    Dim varModule As Integer = 5

    Sub Main()
        Dim locSingleton As Singleton = Singleton.GetInstance()
        Dim locSingleton2 As Singleton = Singleton.GetInstance()

        Console.WriteLine(locSingleton Is locSingleton2)
        Console.WriteLine()
        Console.WriteLine("Press key to exit!")
        Console.ReadKey()
    End Sub

End Module

Class Singleton

    Private Shared locSingleton As Singleton
    Private Shared locMutex As New Mutex

    'Constructor is private,
    'thus the class can only be instantiated by itself
    Private Sub New()
    End Sub

    'GetInstance retruns a Singleton instance
    'The class can only be instantated by this function
    Public Shared Function GetInstance() As Singleton

        'Make the process thread-safe
        'Waits until an different thread which
        'instantiates this class is finished, so
        'this can't be accidently happening
        'on multicore processors at the same time.
        '(See last chapter in book for more!)
        locMutex.WaitOne()

        Try
            If locSingleton Is Nothing Then
                locSingleton = New Singleton
            End If
        Finally

            'Instantiation complete,
            '...can continue...
            locMutex.ReleaseMutex()
        End Try

        'Return instance
        Return locSingleton

    End Function
End Class