Module Module1

    Sub Main()

        Dim anInteger As Integer
        'Dim aLong As Long = 1000
        Dim aLong As Long = Integer.MaxValue ' + 1L
        'anInteger = aLong

        'Crashes at runtime: Integer.MaxValue+1 doesn't fit into an integer:
        'anInteger = CInt(aLong)

        anInteger = CType(aLong, Integer)
        anInteger = Convert.ToInt32(anInteger)

        Dim aStringWithDate As String = "24122003"
        Dim anOtherStringWithDate As String = "2412"
        Dim aStringWithDouble As String = "1.123,23 "
        Dim aDate As DateTime
        Dim aDouble As Double

        'An Array of possible date formates for Date.ParseExact 
        Dim DateformattingFormat() As String = New String() {"ddMMyyyy", "ddMM"}

        'Exmaples for converting date values:
        aDate = DateTime.ParseExact(aStringWithDate, _
                                       DateformattingFormat, _
                                       Nothing, _
                                       Globalization.DateTimeStyles.AllowWhiteSpaces)

        Console.WriteLine("Date " & aDate.ToString("ddd, dd.MMM.yyyy"))

        aDate = DateTime.ParseExact(anOtherStringWithDate, _
                                       DateformattingFormat, _
                                       Nothing, _
                                       Globalization.DateTimeStyles.AllowWhiteSpaces)
        Console.WriteLine("Date " & aDate.ToString("ddd, dd.MMM.yyyy"))

        'Number exmaples:
        aDouble = Double.Parse(aStringWithDouble, Globalization.NumberStyles.Currency)
        Console.WriteLine("Value " & aDouble.ToString("#,###.## $"))


        'This way you can catch wrong input formats:

        'Version 1: Via TryParse (available for date and num types:)
        If Double.TryParse("1,234.56", aDouble) Then
            Console.WriteLine("String could be parsed: " & aDouble.ToString)
        Else
            Console.WriteLine("String could not be parsed!")
        End If

        'Version 2: with try/catch handling.
        Try
            'This will not work.
            aDate = DateTime.ParseExact("2005_12_24", _
                               DateformattingFormat, _
                               Nothing, _
                               Globalization.DateTimeStyles.AllowWhiteSpaces)

        Catch ex As Exception
            Console.WriteLine("Parsing caused an exception:" & vbNewLine & _
                ex.Message)
        End Try

        'Class casting
        Dim locAClass As aClass
        Dim locDerivedClass As DerivedClass = New DerivedClass

        'Implicit casting is possible, because in the inheritance hierarchy it moves towards base class
        locAClass = locDerivedClass

        'Doesn't work; function isn't present.
        'locAClass.AddValues()

        'Doesn't work either; it moves further down in the inheritance hierarchy,
        'and then implicit conversion isn't possible:
        'locDerivedClass = locAClass

        'This works:
        locDerivedClass = DirectCast(locAClass, DerivedClass)
        locDerivedClass.AddValues()

        Console.WriteLine("Derived: " & locDerivedClass.ToString())
        Console.WriteLine("Value Pair: " & locAClass.ToString())

        'Boxen of value types
        Dim locObjectArray(9) As Object
        Dim locRandom As New Random(Now.Millisecond)
        Dim locMaxValue As Integer

        For locCount As Integer = 0 To 9
            'Implicit casting is possible; it moves up in the inheritance hierarchy
            'But take cover!  We're boxing!
            locObjectArray(locCount) = New Matryoshka(locRandom.Next)
        Next

        'Find out which object had the highest generation number
        For locCount As Integer = 0 To 9
            'There are only Matryoshka values in the array, but the array
            'only knows objects. The Generation property is not available.
            'Therefore this line doesn't work:
            'locMaxValue = locObjectArray(locCount).Generation
            Dim locMatryoshka As Matryoshka
            'UnboxingThe referenced vlaue type is turned bach into "true" value
            locMatryoshka = DirectCast(locObjectArray(locCount), Matryoshka)
            'Now we get to the Generation property:
            If locMaxValue < locMatryoshka.Generation Then
                locMaxValue = locMatryoshka.Generation
            End If
        Next
        Console.WriteLine("The highest generation number was: " &
        locMaxValue.ToString())
        Console.WriteLine()
        Console.WriteLine("Press return to exit!")
        Console.ReadLine()

    End Sub

End Module

Structure Matryoshka
    Private myGeneration As Integer

    Sub New(ByVal Generation As Integer)
        myGeneration = Generation
    End Sub

    Property Generation() As Integer
        Get
            Return myGeneration
        End Get
        Set(ByVal Value As Integer)
            myGeneration = Value
        End Set
    End Property

End Structure

Class aClass

    Protected value1 As Integer
    Protected value2 As Integer

    Sub New()
        value1 = 10
        value2 = 20
    End Sub

    Public Overrides Function ToString() As String
        Return value1.ToString
    End Function

End Class

Class DerivedClass
    Inherits aClass

    Public Sub AddValues()
        value1 += value2
    End Sub

End Class

