Module mdlMain

    Sub Main()
        'A regular object which could normally be finalized without issues
        Dim locTest1 As New TestClass(False, "First test object")
        'but here's the problem: a queue loop flag is set.
        Dim locTest2 As New TestClass(True, "Second test object")
    End Sub

End Module

Class TestClass

    'This flag controls the entry into the queue.
    Private myWaitInFinalize As Boolean
    'A property for differentiating class instances
    Private myName As String

    'Flag for waiting and defining the name.
    Sub New(ByVal WaitInFinalize As Boolean, ByVal Name As String)
        myWaitInFinalize = WaitInFinalize
        myName = Name
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()

        'Only jump into the queue
        'if the flag was set at New.
        If myWaitInFinalize Then

            Dim locSecs As Integer
            Dim lastSec As Integer

            lastSec = Now.Second

            Do

                'Issue a message every second.
                If lastSec <> Now.Second Then
                    lastSec = Now.Second
                    locSecs += 1
                    Console.WriteLine("Waiting {0} seconds", locSecs)

                    'After 60 seconds it would end.
                    If locSecs = 60 Then Exit Do

                End If
            Loop
        End If

        'Successfully finalized --> issue message
        Console.WriteLine("object {0} was finalized!", myName)
    End Sub
End Class