Module ComparerBeispiel



    Sub Main()
        Dim someAddresses(5) As Address

        someAddresses(0) = New Address("Ardelean", "Adriana", "90820", "Encinitas CA")
        someAddresses(1) = New Address("Lffelmann", "Klaus", "90210", "Encinitas CA")
        someAddresses(2) = New Address("Heckhuis", "Jrgen", "90210", "Los Angeles CA")
        someAddresses(3) = New Address("Hora", "Cate", "90210", "Pompano Beach FL")
        someAddresses(4) = New Address("Hora", "Oli", "90210", "Pompano Beach FL")
        someAddresses(5) = New Address("Merkel", "Angela", "54923", "Berlin WI")

        Console.WriteLine("List of addresses:")
        Console.WriteLine(New String("="c, 40))
        PrintAddresses(someAddresses)

        Array.Sort(someAddresses)
        Console.WriteLine()
        'Console.WriteLine("Adressenliste (sortiert nach Postleitzahl):")
        Console.WriteLine("Adressenliste (sortiert):")
        Console.WriteLine(New String("="c, 40))
        'Array.Sort(locAdressen, New AdressenVergleicher(ZuVergleichen.PLZ))
        PrintAddresses(someAddresses)
        Console.ReadLine()
    End Sub

    Sub PrintAddresses(ByVal Adress As Address())
        For Each locString As Address In Adress
            Console.WriteLine(locString)
        Next
    End Sub

End Module

Public Class Address
    Implements IComparable

    Sub New(ByVal LastName As String, ByVal FirstName As String, _
            ByVal Zip As String, ByVal CityAndCountryCode As String)
        Me.LastName = LastName
        Me.FirstName = FirstName
        Me.Zip = Zip
        Me.CityAndCountryCode = CityAndCountryCode
    End Sub

    'Auto-Implemented Properties
    Public Property LastName() As String
    Public Property FirstName() As String
    Public Property CityAndCountryCode() As String
    Public Property Zip() As String

    Public Function CompareTo(ByVal obj As Object) As Integer Implements System.IComparable.CompareTo

        Dim locAdresse As Address

        Try
            locAdresse = DirectCast(obj, Address)
        Catch ex As InvalidCastException
            Dim up As New InvalidCastException("'CompareTo' of class 'Address' cannot be compared " + _
                                               "with objects of different tz!")
            Throw up
        End Try
        Return ToString.CompareTo(locAdresse.ToString)
    End Function

    Public Overrides Function ToString() As String
        Return LastName + ", " + FirstName + ", " + Zip + " " + CityAndCountryCode
    End Function
End Class

'Just for more easy handling.
Public Enum ToCompare
    LastName
    ZIP
    CityAndCountryCode
End Enum

Public Class AddressComparer
    Implements IComparer

    'Stores the "compare with" setting.
    Protected myCompareWith As ToCompare

    Sub New(ByVal compareWith As ToCompare)
        myCompareWith = compareWith
    End Sub

    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
                                            Implements System.Collections.IComparer.Compare
        'Only allow certain types:
        If (Not (TypeOf x Is Address)) Or (Not (TypeOf y Is Address)) Then
            Dim up As New InvalidCastException("'Compare' der Klasse 'Adressenvergleicher' kann nur " + _
                                               "Vergleiche vom Typ 'Adresse' durchfhren!")
            Throw up
        End If

        Dim locAdr1 As Address = DirectCast(x, Address)
        Dim locAdr2 As Address = DirectCast(y, Address)

        'Here is where the actual magic happens,
        'so what the actual sorting criteria is.
        If myCompareWith = ToCompare.LastName Then
            Return locAdr1.LastName.CompareTo(locAdr2.LastName)
        ElseIf myCompareWith = ToCompare.CityAndCountryCode Then
            Return locAdr1.CityAndCountryCode.CompareTo(locAdr2.CityAndCountryCode)
        Else
            Return locAdr1.Zip.CompareTo(locAdr2.Zip)
        End If

    End Function

    'For accessing the compare with setting from outside
    Public Property CompareWith() As ToCompare
        Get
            Return myCompareWith
        End Get
        Set(ByVal Value As ToCompare)
            myCompareWith = Value
        End Set
    End Property

End Class