Imports System.Collections.ObjectModel

Module KeyedCollection

    Sub Main()
        'Firstly, define an ordinary ArrayList 
        'which contains 100 random addresses.
        Dim locArrayList As ArrayList = Address.RandomAddresses(100)

        'This is the custom KeyedCollection:
        Dim locKeyedAdressen As New Addresses

        'We populate the KeyedCollection with the items from the array list.
        For Each locAdressItem As Address In locArrayList
            locKeyedAdressen.Add(locAdressItem)
        Next

        'Accessing the items from the KeyedCollection.
        'Variation No. 1: accessing via the index:
        For c As Integer = 0 To 10
            Console.WriteLine(locKeyedAdressen(c).ToString)
        Next

        Console.WriteLine()

        'Get an arbitrary one, just to have a matchcode:
        Dim locMatchcode As String = locKeyedAdressen(10).Matchcode

        Dim locAdresse As Address = locKeyedAdressen(locMatchcode)
        Console.WriteLine("The address with matchcode " & locMatchcode & " is:")
        Console.WriteLine(locAdresse.ToString)
        Console.WriteLine()
        Console.WriteLine("Press any key to quit!")
        Console.ReadKey()
    End Sub
End Module

''' <summary>
''' Manages objects of type Address as dictionary:
''' Derived from the abstract basae class KeyedCollection.
''' </summary>
''' <remarks></remarks>
Public Class Addresses
    Inherits KeyedCollection(Of String, Address)

    'This method must be overwritte to ensure,
    'the every item has a key.
    Protected Overrides Function GetKeyForItem(ByVal item As Address) As String
        'This definies the matchcode as the unique key for each item.
        Return item.Matchcode
    End Function
End Class
