Imports System.IO

Public Class Address

    Private myDateCreated As DateTime
    Private myCreatedBy As String

    Sub New(ByVal FirstName As String, ByVal LastName As String, ByVal Street As String, ByVal ZipCity As String)
        'Constructor creates all backing fields.
        Me.LastName = LastName
        Me.FirstName = FirstName
        Me.Street = Street
        Me.ZipCity = ZipCity
        myDateCreated = DateTime.Now
        myCreatedBy = My.User.Name
    End Sub

    'Write all public properties to the file.
    Public Shared Sub SerializeToFile(ByVal adr As Address, ByVal Filename As String)

        'In Addition to the book's printed sample, 
        'let's check, if the folder exist and if not, create it.
        Dim locFileInfo As New FileInfo(Filename)

        'We can easly access the padth part of the full filename
        'with the directory property, and check, if it exists
        'with the exist method.
        If Not locFileInfo.Directory.Exists Then
            'If it does not exist, we create it - it's that simple! :-)
            locFileInfo.Directory.Create()
        End If

        'Here continues the original sample.
        Dim locStreamWriter As New StreamWriter(Filename, False, System.Text.Encoding.Default)
        With locStreamWriter
            .WriteLine(adr.FirstName)
            .WriteLine(adr.LastName)
            .WriteLine(adr.Street)
            .WriteLine(adr.ZipCity)
            .Flush()
            .Close()
        End With
    End Sub

    'Read the stream of data from the file and create a new address object out of that.
    Public Shared Function SerializeFromFile(ByVal Filename As String) As Address
        Dim locStreamReader As New StreamReader(Filename, System.Text.Encoding.Default)
        Dim locAddress As Address
        With locStreamReader
            locAddress = New Address(.ReadLine, .ReadLine, .ReadLine, .ReadLine)
        End With
        locStreamReader.Close()
        Return locAddress
    End Function

    Public Property LastName() As String
    Public Property FirstName() As String
    Public Property Street() As String
    Public Property ZipCity() As String

    'The following properties are read only, because the developer 
    'shouldn't be able to manipulate this date.
    Public ReadOnly Property DateCreated() As DateTime
        Get
            Return myDateCreated
        End Get
    End Property

    Public ReadOnly Property CreatedBy() As String
        Get
            Return myCreatedBy
        End Get
    End Property


End Class
