﻿Module LinqDemo
    Private Const ELEMENTCOUNT = 100

    Private adrList As List(Of Contact) = Contact.RandomContacts(ELEMENTCOUNT)
    Private prdList As List(Of Product) = Product.RandomProducts(adrList)

    Sub Main()

        Dim adrListGrouped = From adrElement In adrList _
                                Join artElement In prdList _
                                On adrElement.ID Equals artElement.IDPurchasedBy _
                                Select adrElement.ID, adrElement.LastName, _
                                       adrElement.FirstName, adrElement.ZipAndCountry, _
                                       artElement.ProductNo, artElement.ProductName, _
                                       artElement.Amount, artElement.UnitPrice, _
                                       ItemPrice = artElement.Amount * artElement.UnitPrice _
                                Order By LastName, ProductNo _
                                Where (ZipAndCountry > "0" And ZipAndCountry < "50000") _
                                Group ProductNo, ProductName, _
                                      Amount, UnitPrice, ItemPrice _
                                By ID, LastName, FirstName _
                                Into Artikelliste = Group, ProductCount = Count(), _
                                     TotalPrice = Sum(ItemPrice)
                                Where TotalPrice > 1000

        For Each KundenItem In adrListGrouped
            With KundenItem
                Console.WriteLine(.ID & ": " & .LastName & ", " & .FirstName & " - " & .ProductCount & " Products for total " & .TotalPrice & " $")
                Console.WriteLine("     Details:")
                For Each ArtItem In KundenItem.Artikelliste
                    With ArtItem
                        Console.WriteLine("     " & .ProductNo & ": " & .ProductName & _
                                          "(" & .Amount & " Piece(s) in total " _
                                          & (.UnitPrice * .Amount).ToString("#,##0.00") & " $)")
                    End With
                Next
            End With

        Next
        Console.ReadKey()

    End Sub

End Module
