
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 07/06/2011 18:27:37
-- Generated from EDMX file: C:\Users\andreasb\Documents\Visual Studio 2010\Projects\Inheritance\Inheritance\Inheritance.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [myNewDatabase];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------


-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Employee]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Employee];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Employee'
CREATE TABLE [dbo].[Employee] (
    [EmployeeID] int IDENTITY(1,1) NOT NULL,
    [LastName] nvarchar(max)  NOT NULL,
    [FirstName] nvarchar(max)  NOT NULL,
    [Birthday] datetime  NOT NULL,
    [CreatedOn] datetime  NOT NULL,
    [EmployeeType] smallint  NOT NULL
);
GO

-- Creating table 'Employee_ProjectManager'
CREATE TABLE [dbo].[Employee_ProjectManager] (
    [EmployeeID] int  NOT NULL
);
GO

-- Creating table 'Employee_Assistant'
CREATE TABLE [dbo].[Employee_Assistant] (
    [EmployeeID] int  NOT NULL,
    [ProjectManager_EmployeeID] int  NOT NULL
);
GO

-- Creating table 'Employee_Developer'
CREATE TABLE [dbo].[Employee_Developer] (
    [EmployeeID] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [EmployeeID] in table 'Employee'
ALTER TABLE [dbo].[Employee]
ADD CONSTRAINT [PK_Employee]
    PRIMARY KEY CLUSTERED ([EmployeeID] ASC);
GO

-- Creating primary key on [EmployeeID] in table 'Employee_ProjectManager'
ALTER TABLE [dbo].[Employee_ProjectManager]
ADD CONSTRAINT [PK_Employee_ProjectManager]
    PRIMARY KEY CLUSTERED ([EmployeeID] ASC);
GO

-- Creating primary key on [EmployeeID] in table 'Employee_Assistant'
ALTER TABLE [dbo].[Employee_Assistant]
ADD CONSTRAINT [PK_Employee_Assistant]
    PRIMARY KEY CLUSTERED ([EmployeeID] ASC);
GO

-- Creating primary key on [EmployeeID] in table 'Employee_Developer'
ALTER TABLE [dbo].[Employee_Developer]
ADD CONSTRAINT [PK_Employee_Developer]
    PRIMARY KEY CLUSTERED ([EmployeeID] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [ProjectManager_EmployeeID] in table 'Employee_Assistant'
ALTER TABLE [dbo].[Employee_Assistant]
ADD CONSTRAINT [FK_ProjectManagerAssistant]
    FOREIGN KEY ([ProjectManager_EmployeeID])
    REFERENCES [dbo].[Employee_ProjectManager]
        ([EmployeeID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProjectManagerAssistant'
CREATE INDEX [IX_FK_ProjectManagerAssistant]
ON [dbo].[Employee_Assistant]
    ([ProjectManager_EmployeeID]);
GO

-- Creating foreign key on [EmployeeID] in table 'Employee_ProjectManager'
ALTER TABLE [dbo].[Employee_ProjectManager]
ADD CONSTRAINT [FK_ProjectManager_erbt_Employee]
    FOREIGN KEY ([EmployeeID])
    REFERENCES [dbo].[Employee]
        ([EmployeeID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [EmployeeID] in table 'Employee_Assistant'
ALTER TABLE [dbo].[Employee_Assistant]
ADD CONSTRAINT [FK_Assistant_erbt_Employee]
    FOREIGN KEY ([EmployeeID])
    REFERENCES [dbo].[Employee]
        ([EmployeeID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [EmployeeID] in table 'Employee_Developer'
ALTER TABLE [dbo].[Employee_Developer]
ADD CONSTRAINT [FK_Developer_erbt_Employee]
    FOREIGN KEY ([EmployeeID])
    REFERENCES [dbo].[Employee]
        ([EmployeeID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------