Imports System.Threading

Public Class frmMain

    'Member-Variable, so we can serially number the threads.
    'This is just for later examining purposes of the executing thread,
    'if it shows the results in the output window.
    Private myWorkerThreadNo As Integer = 1
    Private myThreadString As String

    'We need these to detect how many threads there are.
    Private myThreadCount As Integer
    'This is the worker thread responsible for
    'incrementing and the value output.
    Private Sub ExtensiveCalculation()

        Dim strTemp As String
        Dim stepCount As Integer

        'New thread: count!
        myThreadCount += 1

        'The critical section starts here.
        Monitor.Enter(Me)

        For c As Integer = 0 To 50
            strTemp = Thread.CurrentThread.Name + ": " + c.ToString

            'The thread waits for 1 second. If it cannot access the code
            'in this time it exits.

            'Access was granted. Now the worker thread starts
            'working.
            myThreadString = ""
            For z As Integer = 0 To strTemp.Length - 1
                myThreadString += strTemp.Substring(z, 1)
                Thread.Sleep(1)
            Next

            ThreadSafeTextWindow.TSWriteLine(myThreadString)

            'The thread can only go to sleep if at least one
            'other thread is available to wake it up again.
            If myThreadCount > 1 Then
                stepCount += 1
                If stepCount = 5 Then
                    stepCount = 0

                    'Relief is on the way!
                    Monitor.Pulse(Me)
                    ThreadSafeTextWindow.TSWriteLine("Gotcha! Your turn!")

                    'The replaced thread goes to sleep.
                    Monitor.Wait(Me)
                End If

            End If
        Next

        If myThreadCount > 1 Then

            'All other threads are sleeping now.
            'At least one thread has to wake up before this thread leaves.
            'Otherwise the other threads will sleep until the next power outage...
            Monitor.Pulse(Me)
        End If

        'The critical section ends here.
        Monitor.Exit(Me)
        'Decrement thread counter.
        myThreadCount -= 1
    End Sub

    Private Sub btnStartThread_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                        Handles btnStartThread.Click
        'Thios object encapsulates the actual thread.
        Dim locThread As New Thread(AddressOf ExtensiveCalculation)

        'Will be prematurely ended when the application ends.
        locThread.IsBackground = True

        'Set the thread's name:
        locThread.Name = "Working-thread: " + myWorkerThreadNo.ToString

        'Start the thread.
        locThread.Start()

        'Counter, so we can distinguish the threads.
        myWorkerThreadNo += 1

    End Sub

    Private Sub btnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuit.Click
        Me.Close()
    End Sub

End Class
