Imports System.Threading

Public Class frmMain

    'Member-Variable, so we can serially number the threads.
    'This is just for later examining purposes of the executing thread,
    'if it shows the results in the output window.
    Private myArbeitsThreadNr As Integer = 1

    'Storage for Mutex objects
    Private myMutexes() As Mutex

    'Storage for TextBox controls
    Private myTxtBoxes() As TextBox

    'Random generator for artificial waiting times in the
    'worker thread. The duration of the thread can be different.
    Private myRandom As Random

    Public Sub New()
        MyBase.New()

        ' This call is required for the Windows Form Designer.
        InitializeComponent()

        'Mutexes definieren
        myMutexes = New Mutex() {New Mutex, New Mutex, New Mutex}

        'Assign Textbox array
        myTxtBoxes = New TextBox() {txtHardware1, txtHardware2, txtHardware3}

        'Initialize the random generator
        myRandom = New Random(DateTime.Now.Millisecond)
    End Sub

    Private Sub btnStartThread_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                        Handles btnStartThread.Click

        Dim locThread As New Thread(
        Sub()

            Dim locMutexIndex As Integer
            Dim locTextBox As TextBox

            'The critical section starts here
            'Wait until a TextBox is available
            locMutexIndex = Mutex.WaitAny(myMutexes)

            'Search for Textbox that matches the available mutex
            locTextBox = myTxtBoxes(locMutexIndex)

            For c As Integer = 0 To 50
                SyncLock Me
                    If Me.IsHandleCreated Then

                        'Display text in the found TextBox
                        '(Because it is delegates to the UI thread,
                        'the detour through Invoke is necessary).
                        Me.BeginInvoke(Sub(tb As TextBox, txt As String)
                                           tb.Text += txt
                                           tb.SelectionStart = tb.Text.Length - 1
                                           tb.ScrollToCaret()
                                       End Sub, {locTextBox,
                        Thread.CurrentThread.Name + ": " +
                        c.ToString + vbNewLine})
                    End If
                End SyncLock

                'Wait for any length of time
                Thread.Sleep(myRandom.Next(50, 400))
            Next

            'Here the critical section ends.
            'Release the used TextBox (Mutex)
            myMutexes(locMutexIndex).ReleaseMutex()
        End Sub)

        locThread.IsBackground = True
        locThread.Name = "Working-thread: " + myArbeitsThreadNr.ToString

        'Start Thread
        locThread.Start()

        'Counter to distinguish the threads by their names.
        myArbeitsThreadNr += 1

    End Sub

    Private Sub btnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuit.Click
        Me.Close()
    End Sub
End Class

